class GeodataController < ResponseController
  def countries
    begin
      raw_haystack = Country.where(["match (name) against (? in boolean mode)", "#{params[:name]}*"]).limit(5)
      # raw_haystack = Country.where("name LIKE '#{params[:name]}%'").limit(10)
      haystack = raw_haystack.pluck(:name)

      @response.set_state 'ok'
      @response.add_var({haystack: haystack})
    rescue Exception => error
      @response.error_state error
    end

    send_response

  end

  def cities
    begin
      country = @current_user.country
      if country
        raw_haystack = country.cities.where(["match (name) against (? in boolean mode)", "#{params[:name]}*"]).limit(5)
      else
        raw_haystack = City.where(["match (name) against (? in boolean mode)", "#{params[:name]}*"]).limit(5)
      end
      haystack = raw_haystack.pluck(:name)

      @response.set_state 'ok'
      @response.add_var({haystack: haystack})
    rescue Exception => error
      @response.error_state error
    end

    send_response
  end

  def set_country
    begin
      country = Country.find_by(name: params.require(:country)[:name])

      if country
        @current_user.update(country: country)
        # обнуление города если страна его не содержит
        city = nil
        if @current_user.city.present?
          if country.cities.ids.include?(@current_user.city.id)
            city = @current_user.city.name
          else
            @current_user.update(city: city)
          end
        end
        @response.add_var ({city: city})
        @response.set_state 'ok'
      else
        @response.add_detail 'страна не найдена в базе данных'
      end

    rescue Exception => error
      @response.error_state error
    end

    send_response
  end

  def set_city
    begin
      city = City.find_by(name: params.require(:city)[:name])

      if city
        @current_user.update(city: city)
        @response.set_state 'ok'
        @response.add_var ({country: @current_user.country.name})
      else
        @response.add_detail 'страна не найдена в базе данных'
      end

    rescue Exception => error
      @response.error_state error
    end

    send_response
  end

end