class NicknameAccessCardsController < ApplicationController
  layout false, only: [:create, :update]
  before_action :set_access_card, only: [:update, :destroy]

  def create
    if edit_checkout @access_card
      @access_card = NicknameAccessCard.new(access_card_params)
      if @access_card.save
        @result = :ok
      else
        @result = :fail
      end
    end
  end

  def destroy
    @access_card.destroy
  end

  private
  # Use callbacks to share common setup or constraints between actions.
  def set_access_card
    @access_card = NicknameAccessCard.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def access_card_params
    params.require(:nickname_access_card).permit(:user_id, :value, :active)
  end
end
