class StartKitController < ActionController::Base

  protect_from_forgery with: :exception

  before_action :charge_session_manager, :access_level_control

  def charge_session_manager
    $session_manager.set_session session
    $session_manager.set_cookies cookies
  end

  # уровень доступа
  def access_level_control
    current_user

    if CONFIG[:access_levels][controller_name.to_sym].present?
      access_node = CONFIG[:access_levels][controller_name.to_sym].select{|level, actions| actions.include?(action_name)} # концентрация мозга и волшебство Ruby, это прекрасно
      if access_node.any?
        access_granted = @current_user_card && CONFIG[:access_aliases][@access_level] >= CONFIG[:access_aliases][access_node.keys.first] # сюда вложено многое при Идеальной структуре конфигурационнного YAML!
        unless check_access_level(:admin)
          if access_granted && /edit/ =~ action_name # доп проверка на случай лайфхакеров желающих заняться редактированием не своих объектов, допускается редактирование всеми начиная с редактора
            # с проверкой на friendly id
            object = ActiveRecord::Base.connection.column_exists?(controller_name, :slug) ? controller_name.classify.constantize.friendly.find(params[:id]) : controller_name.classify.constantize.find(params[:id])
            access_granted = edit_checkout object
          end
        end

        redirect_to "/401.html" unless access_granted
      end
    end
  end

  def current_user
    unless session[:uid].nil?
      @current_user_card = UserCard.find_by(id: session[:uid])
      @access_level = @current_user_card.access_level.to_sym
    else
      @current_user_card = nil
    end

    @current_user = @current_user_card.nil? ? nil : @current_user_card.userable
    @active_card = @current_user_card.my_active_card unless @current_user.nil?
  end

  helper_method :current_user


  # def cookie_authorize
  #   user = UserCard.find_by(id: cookies[:uid])
  #   if user.present? && cookies[:chk] == Digest::MD5.new.update("#{user.id}#{'pussy'}#{user.password_digest}")
  #     user.authenticate(user.password)
  #     session[:uid] = user.id
  #     user
  #   else
  #     nil
  #   end
  # end

  def edit_checkout object
    begin
      master = object.my_master
    rescue
      master = nil
    end

    if (check_access_level CONFIG[:access_edit_bottom].to_sym)
      access_granted = true
    else
      if master && @current_user
        access_granted = (master.id == @current_user.id)
      end
    end

    access_granted
  end

  helper_method :edit_checkout

  # запрос достиг ли юзер уровня доступа алиаса
  def check_access_level _alias
    @current_user_card && CONFIG[:access_aliases][@access_level] >= CONFIG[:access_aliases][_alias] # сюда вложено многое при Идеальной структуре конфигурационнного YAML!
  end

  helper_method :check_access_level

end
