class UserCardsController < ResponseController

  require 'sms_lib'

  require 'digest'

  def authorization
    @access_cards_placeholder = UserCard.access_cards_placeholder
  end
  def registration
  end

  def confirmation
    template = 'user_cards/confirmation_but_access_code'

    if params[:access_code].present? && params[:id].present?
      access_code = params[:access_code]
# мощная проверка - мощный результат ! вместе сделаем Мощный рывок вперёд ! )) за Жириновского !!11
      user_card = UserCard.find_by(id: params[:id])
      if user_card.present? && user_card.passive?
        if user_card.confirm_access_code == access_code
          user_card.confirm
          template = 'user_cards/confirmation_complete'
        end
      end
    end

    render template: template

  end

  def login
    # если не мыло то вырезается всякий код страны
    if (/@/ =~ params[:login]).nil?
      params[:login] = params[:login].to_s.phone_cutter_cc
    end

    # предварительное определение типа логина
    login_type_result = login_type params[:login]
    access_card = login_type_result[:access_card]
    sign_as = login_type_result[:sign_as]

    disclaimer = login_type_result[:sign_as].nil? ? CONFIG[:access_cards_info][:bad_login_fiasco_disclaimer] : CONFIG[:access_cards_info][:bad_login_disclaimer].sub(/мистер/, I18n.t(login_type_result[:sign_as], scope: 'access_cards'))
    @response.add_var ({disclaimer: disclaimer })

    unless access_card.nil?
      user_card = access_card.user_card

      if user_card.authenticate(params[:password])
        user_card.authorize! access_card
        current_user

        @response.set_url profile_path
        @response.add_detail 'login'
        @response.set_state 'ok'
      else
        # пароль не подходит
        session[:ressurection_uid] = user_card.id

        @response.add_var ({have_email: user_card.email_access_cards.where.not(value: nil).any?})
        @response.add_detail 'bad_password'
      end
    else
      # регистрация + авторизация
      if sign_as.present? && sign_as != :id
      #   user = Client.create get_params ActionController::Parameters.new({user: {password: params[:password], "#{sign_as.downcase}_access_cards_attributes" => [{value: params[:login]}]}})
      #   if user
      #     access_card = "#{sign_as.downcase}AccessCard".classify.constantize.find_by(user_id: user.id)
      #     user.user_card.authorize! access_card

          @response.set_url root_path
          @response.add_detail 'reg'
          @response.set_state 'ok'
      # end
      else
        # вводи норм логин
        CONFIG[:access_by].each do |by, options|
          if /#{options[:nearly]}/i =~ params[:sign_as]
            disclaimer = options[:disclaimer]
            break
          end
        end

        @response.add_detail 'bad_login'
        @response.set_state 'bad'
      end
      # end
    end

    send_response

  end

  def add_access_card
    params[:classname].constantize.create(user_id: @current_user.id)

    render json: {answer: 'ok'}
  end

  def remove_access_card
    params[:classname].constantize.find(params[:id]).destroy

    render json: {answer: 'ok'}
  end

  def send_phone_confirmation
    phone = params[:phone].to_s.phone_cutter
    if phone =~ /^\d{10}$/
      result[:code] = rand 1000..9999
      session[:code] = encode64 code
      # sms_phone_verify_code phone, code
      # @code = code
      session[:sms_verify_attempt] = 5
      session[:phone] = phone
      @response.set_state 'ok'
    else
      @response.add_detail 'неправильный номер'
    end

    send_response

  end

  def verify_phone_confirmation
    result = {answer: 'ok'}

    if session[:sms_verify_attempt] < 2
      session[:code] = nil
      result[:answer] = 'attemptsgone'
    else
      if (encode64 params[:code]) == session[:code]
        if @current_user
          access_card = @current_user.phone_access_cards.find_by(value: params[:phone])
          if access_card
            access_card.update(verified: 1)
          else
            result[:answer] = 'phonelost'
          end
        else
          result[:answer] = 'userlost'
        end
      else
        result[:answer] = 'wrongcode'

        session[:sms_verify_attempt] -= 1
      end
    end

    result[:attempt] = session[:sms_verify_attempt]

    render json: result

  end

  def password_reset

    details = []
    state = 'ok'

    resurrection =  SecureRandom.hex(8)
    user_card = UserCard.find_by(id: session[:ressurection_uid])
    if user_card
      begin
        unless user_card.update(resurrection: resurrection)
          state = 'shit'
          details << 'невозможно записать код доступа'
        else
          uri = URI.join(request.base_url, 'resurrection')
          params = { :resurrection_code => resurrection }
          uri.query = URI.encode_www_form(params)

          UserCardsMailer.resurrection(user_card.my_email, uri.to_s).deliver_now

          # снаряжаем фоновую задачу правильным образом !
          kill_time = DateTime.now + CONFIG[:resurrection_ttl].to_i.minutes
          PasswordResurrectionKillJob.set(wait_until: kill_time).perform_later(user_card.id)
        end
      rescue Exception => error
        state = 'shit'
        details << error.message
      end
    else
      state = 'shit'
      details << 'пользователь не найден'
    end

    render json: {state: state, details: details}

  end

  def resurrection
    if params[:resurrection_code].present?
      @resurrection_code = params[:resurrection_code]
      user_card = UserCard.find_by(resurrection: params[:resurrection_code])
      if user_card.nil?
        render template: 'user_cards/resurrection_but_access_code'
      end
    else
      render template: 'user_cards/resurrection_no_access_code'
    end
  end

  def resurrection_password_update
    user_card = UserCard.find_by(resurrection: params[:resurrection_code])
    unless user_card.nil?
      if user_card.update(password: params[:password], resurrection: nil)
        # require 'authorizer'
        # authorizer = Authorizer.new
        # authorizer.authorize! user_card, user_card.email_access_cards.first
        user_card.authorize! user_card.email_access_cards.first
        current_user

        redirect_to root_url
      end
    end
  end

  def check_login_by
    value = params[:by] == 'phone' ? params[:value].to_s.phone_cutter : params[:value]
    unless (/#{CONFIG[:access_by][params[:by].to_sym][:truly]}/i =~ value).nil?
      # проверка на совпадение логина в любом из полей указанных в конфиге (разрешённых для аутентификации) - при совпадении авторизация, в противном случае - регистрация
      value.downcase! if value.class.name == 'String' # к общему знаменателю все эти строки
      state = "#{params[:by]}AccessCard".classify.constantize.find_by(value: value).nil? ? 'reg' : 'login'
      # подтверждение по смс
      state = 'reg' if session[params[:by]] == value
    else
      state = 'bad_login'
    end

    @response.add_var ({disclaimer: CONFIG[:access_by][params[:by].to_sym][:disclaimer], fieldname: params[:by]})

    @response.set_state state

    send_response
  end

  def check_login
    login_type_result = login_type params[:login]
    access_card = login_type_result[:access_card]
    sign_as = login_type_result[:sign_as]

    state = 'bad_login'
    unless sign_as.nil?
      unless access_card.nil?
        state = 'login'
      else
        state = 'reg'
      end
    end

    render json: {state: state, sign_as: sign_as}
  end

  def login_type login
    # предварительное определение типа логина
    access_card = nil
    sign_as = nil
    CONFIG[:access_by].each do |by, options|
      unless (/#{options[:truly]}/i =~ login).nil?
        # проверка на совпадение логина в любом из полей указанных в конфиге (разрешённых для аутентификации) - при совпадении авторизация, в противном случае - регистрация
        login.downcase! if by == 'email' # к общему знаменателю тока мыло
        access_card = "#{by}AccessCard".classify.constantize.find_by(value: login)
        sign_as = by
        break
      end
    end

    {access_card: access_card, sign_as: sign_as}
  end

  def check_password_line
    begin
      if /#{CONFIG[:access_cards_info][:password_line]}/ =~ params[:value]
        @response.set_state 'ok'
      else
        @response.add_detail CONFIG[:access_cards_info][:password_disclaimer]
      end
    rescue Exception => error
      @response.error_state error.message
    end

    send_response
  end

  def offline
    user = UserCard.find_by(id: params[:uid])
    user.update({online: false}) unless user.nil?
  end

  def logout
    if @current_user_card
      @current_user_card.update({online: false})
      reset_session
    end

    redirect_to root_url
  end

  private

  def encode64 code
    Digest::SHA256.base64digest "#{code} и сольцы пизданём"
  end

end