class Avatar < ApplicationRecord

  belongs_to :imageable, polymorphic: true

  has_attached_file :uploaded_file,
                    :path => ":rails_root/public/avatars/:attachment/:id/:basename_:style.:extension",
                    :url => "/avatars/:attachment/:id/:basename_:style.:extension",
                    :styles => {
                        :default          => ['220x220#',  :png, :quality => 100],
                        :preview          => ['130x130#',  :png, :quality => 100],
                    },
                    :convert_options => {
                        :default          => '-set colorspace sRGB -strip',
                        :preview          => '-set colorspace sRGB -strip',
                    }

  validates_attachment :uploaded_file,
                       :presence => true,
                       :size => { :in => 0..10.megabytes },
                       :content_type => { :content_type => /^image\/(jpeg|png|gif|tiff|bmp)$/ }


end