class Client < Prometeus
  extend Enumerize
  extend ActiveModel::Naming

  belongs_to :country
  belongs_to :city

  enumerize :sex, in: %w[male female other], i18n_scope: 'sex'

  scope :males, -> {where(sex: 'male')}
  scope :females, -> {where(sex: 'female')}
  scope :others, -> {where(sex: 'other')}
  scope :birthdays, -> {where('DATE_FORMAT(birthday, "%m%d")=?', DateTime.now.strftime('%m%d'))}

  after_update :check_country

  def happy_birthday?
    require 'happy_birthday'
    self.birthday.happy_birthday?
  end

  # назначение страны если первым выбирается город
  def check_country
    if saved_change_to_attribute?(:city_id)
      unless self.city.nil?
        self.update(country: self.city.country) unless self.country
      end
    end
  end

end