class EmailAccessCard < ApplicationRecord

  belongs_to :user_card

  after_create :greetings_email
  after_update :greetings_email
  # after_destroy :check_active

  before_validation :normalize
  validates :value, presence: true, uniqueness: true, format: {with: /\A([^@\s]+)@((?:[-a-z0-9]+\.)+[a-z]{2,})\z/i}, :allow_blank => false
  validates :value, :length => {:minimum => 6, :message => 'шорты'}

  def check_active
    self.user_card.set_active_card
  end

  def normalize
    self.value.downcase! unless self.value.nil?
  end

  def greetings_email
    unless self.value.blank?
      if saved_change_to_attribute?(:value)
        user = self.user_card.userable
        "#{user.class.name}Mailer".constantize.greetings_email(user).deliver_now
      end
    end
  end

end