class NicknameAccessCard < ApplicationRecord

  belongs_to :user_card

  before_validation :normalize
  validates :value, presence: true, uniqueness: true, format: {with: /\A([a-zA-Z][\w]{0,14})\z/i}, :allow_blank => false

  def normalize
    self.value.downcase!
  end

  # after_destroy :check_active

  def check_active
    self.user_card.set_active_card
  end

end