class Prometeus < ApplicationRecord

  self.abstract_class = true

  has_one :user_card, as: :userable, dependent: :destroy
  has_one :avatar, as: :imageable, dependent: :destroy

  after_create :add_user_card

  validates :name, :length => {:maximum => 64, :message => 'максимальная длина имени 64 символа'}

  scope :not_me, -> (user_card_id) {joins(:user_card).where.not('user_cards.id = ?', user_card_id)}

  def add_user_card
    self.create_user_card({password: 'mussypussy', access_level: self.class.name.underscore})
  end

  def my_nicknames
    self.user_card.my_nicknames
  end

  def my_nickname
    self.user_card.my_nickname
  end

  def my_emails
    self.user_card.my_emails
  end

  def my_email
    self.user_card.my_email
  end

  def my_phones
    self.user_card.my_phones
  end

  def my_phone
    self.user_card.my_phone
  end

  def whoami
    self.class.name.underscore
  end

  def isi _alias
    self.whoami == _alias
  end

end