Rails.application.routes.draw do

  # могущественный action cable!
  mount ActionCable.server => '/cable'

  # админка
  get 'admin' => 'admin#index'

  # вход и регистрация
  resources :clients, only: :create
  get 'authorization' => 'user_cards#authorization'
  get 'registration' => 'user_cards#registration'

  # oauth2
  post 'oauth_authorization' => 'oauth#authorize'
  get 'oauth_verify' => 'oauth#oauth_verify', as: 'oauth_verify'
  get 'openid_verify' => 'oauth#openid_verify', as: 'openid_verify'

  # профиль
  get 'profile' => 'profile#index', as: 'profile'
  post 'profile_update' => 'profile#update'
  # аватар
  post 'add_user_avatar' => 'profile#add_avatar'
  post 'kill_user_avatar' => 'profile#kill_avatar'

  # geodata в профиле
  post 'geodata_countries' => 'geodata#countries'
  post 'geodata_cities' => 'geodata#cities'
  post 'geodata_set_country' => 'geodata#set_country'
  post 'geodata_set_city' => 'geodata#set_city'

  # проверка логина
  post 'check_login' => 'user_cards#check_login'
  # проверка логина по типу
  post 'check_login_by' => 'user_cards#check_login_by'
  # просто авторизация
  post 'login' => 'user_cards#login'
  # проверка соответствия пароля правилам пароля
  post 'check_password_line' => 'user_cards#check_password_line'
  # оффлайн
  post 'offline' => 'user_cards#offline'
  # выход
  get 'logout' => 'user_cards#logout'
  # восстановление пароля
  get 'resurrection' => 'user_cards#resurrection'
  # замена пароля и логин
  post 'resurrection_password_update' => 'user_cards#resurrection_password_update'
  # сброс пароля
  post 'password_reset' => 'user_cards#password_reset'
  # подтверждение аккаунта
  get 'account_confirmation' => 'user_cards#confirmation', as: 'account_confirmation'

end
