class CreateUserCards < ActiveRecord::Migration[5.1]
  def change
    create_table :user_cards do |t|
      t.references :userable, polymorphic: true, index: true
      t.integer :userable_id
      t.string :userable_type
      t.string :access_level, null: true, limit: 32

      t.string :password_digest
      t.string :resurrection, null: true

      t.integer :status, null: true, unsigned: true, index: true, limit: 1, default: 0
      t.boolean :online, null: true, unsigned: true, index: true, default: 0

      t.timestamps null: false
    end

  end
end