class CreateNicknameAccessCards < ActiveRecord::Migration[5.1]
  def change
    create_table :nickname_access_cards do |t|
      t.belongs_to :user_card, index: true, null: false, foreign_key: true

      t.string :value, null: true, index: true, unique: true, limit: 14
      t.boolean :active

      t.timestamps
    end

    add_index :nickname_access_cards, :value, name: :ivalue, type: :fulltext

  end
end
