class SessionManager

  def set_session session
    @session = session
  end

  def set_cookies cookies
    @cookies = cookies
  end

  def authorize! id
    @session[:uid] = id
    @cookies[:uid] = id
    @cookies[:chk] = (Digest::MD5.new.update "#{CONFIG[:pepper]}#{id}#{CONFIG[:salt]}").to_s
  end

  def whoami
    if @session && @session[:uid]
      user = UserCard.find(@session[:uid]).userable
      username = user.name == '' ? "#{user.class.name}##{user.id}" : user.name
      username << " из компании #{user.company.name}" if user.class.name == 'Manager' && user.company.name
      username
    else
      'Anonymous'
    end

  end

  def login_data
    check_login_data
    @session[:login_data]
  end

  def login_data_update account
    @session[:login_data] = {type: account.class.name, id: account.id}
    @session[:uid] = account.user_card.id
  end

  def check_login_data
    begin
      @session[:login_data][:type].constantize.find_by({id: @session[:login_data][:id]}).present?
    rescue
      @session[:login_data] = nil
    end
  end

end